#include <iostream>
using namespace std;
#include <cmath>
////////////////////////////////////////////////////////////////////////////////////////////////////


class myDynamicArray
{

private:
	double * A;
	int size;
public:
	myDynamicArray(int sizeValue);
	myDynamicArray();
	myDynamicArray(const myDynamicArray  & other);
    ~myDynamicArray();
	const myDynamicArray &  operator=(const myDynamicArray & other);
	void copy(const myDynamicArray  & copied);
	
    void set(int i, double x);
	double get(int i) const;
	int getSize() const;

	void print() const;
	
	int search(double query) const;
	bool isSorted() const;
	void insertionSort();


    void concatinate(myDynamicArray & B);

};

////////////////////////////////////////////////////////////////////////////////////////////////////

void  main()
{
	myDynamicArray X(3),Y;
	X.set(0,3.1);
	X.set(1,3.2);
	X.set(2,1.1);
	Y.print();
	Y=X;
	Y.print();


}


////////////////////////////////////////////////////////////////////////////////////////////////////

 
myDynamicArray ::myDynamicArray()
{
	A= new double[10];
	size=10;
	for(int i=0;i<size;i++)
		A[i]=0;
}


 
myDynamicArray ::myDynamicArray(int sizeValue)
{
	size=sizeValue;
	A=new double[size];
	for(int i=0;i<size;i++)
		A[i]=0;
}



 
myDynamicArray ::~myDynamicArray()
{
	delete [] A;
	size = 0;
}



 
myDynamicArray ::myDynamicArray(const myDynamicArray  & other)
{
    copy(other);
}


 
const myDynamicArray &  myDynamicArray ::operator=(const myDynamicArray  & other)
{
	if(this != & other) 
		   copy(other);
	return *this;        
}


 
void myDynamicArray ::set(int i, double x)
{
	A[i] = x;
}
	


 
double myDynamicArray ::get(int i) const
{
	return A[i];
   
}


 
int myDynamicArray ::getSize() const
{
	return size;
   
}



 
int myDynamicArray ::search(double query) const
{
	for(int i=0; i<size; i++)
	if(A[i]==query) return i;
	return -1;
}

 
void myDynamicArray ::print() const
{
	for(int i=0;i<size;i++)
		cout<<A[i]<<" ";
	cout<<endl;
}


 
bool myDynamicArray ::isSorted() const
{
	bool sorted=true;
	for(int i=1;i<size;i++)
		if(A[i-1]>A[i]) sorted=false;
	return sorted;
}


 
void myDynamicArray ::insertionSort()
{
	double temp;
	for(int j=1;j<size;j++) {
		temp=A[j];
		int i;
		for(i=j-1; (A[i]>temp) && (i>-1);i--)
			A[i+1]=A[i];
		A[i+1]=temp;
	}
}


 
void myDynamicArray ::copy(const myDynamicArray & copied)
{
	delete [] A;
	A = new  double[copied.size];
	size=copied.size;
	for(int i=0; i<size; i++)
		 A[i]=copied.A[i];
}

 
void myDynamicArray ::concatinate(myDynamicArray & B)
{
	double * final;
	final = new double[size+B.size];
	for(int i=0;i<size;i++)
		final[i]=A[i];
	int i;
	for(i=size; i<(size+B.size); i++)
		final[i]=B.A[i-size];
	delete [] A;
	A = final;
	size=size + B.size;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////



