#include <iostream>
using namespace std;




template<class T> 
void arrayPrint(T a[], int n);


template<class T> 
void insertionSort(T A[], int n);

template<class T> 
int arraySmallest(T a[],int start,int end);
template<class T> 
void selectionSort(T a[], int n);



template<class T>
void mergeSort(T A[],int p,int r);
template<class T>
void Merge(T  A[], int p, int q, int r);
template<class T>
void merge15(const T L[],int m,const T R[], int n, T C[] );



template<class T>
int partition(T A[],int,int);
template<class T>
void randQuickSort(T A[], int low, int high);


///////////////////////////////////////////////////////////////

template<class T> 
void arrayPrint(T a[], int n){
	for(int i=0;i<n;i++){
		cout << a[i] << " " ;
	}
	cout << endl;
}

/////////////////////////////////////////////////////////////

template<class T> 
void insertionSort(T A[], int n)
{
	for(int j=1;j<n;j++) 
	{
        T key = A[j];
        // Insert A[j] into the sorted sequence  A[0j-1]
        int  i = j-1;
        while(i>=0 && A[i] > key) 
		{ 
              A[i+1] = A[i];  // move the elements ahead
              i =i-1;          // and go one step back
		}
        A[i+1] = key;
    }
}

/////////////////////////////////////////////////////////////////


template<class T> 
int arraySmallest(T a[],int start,int end)
{
	int indexOfMinimum = start;
	for(int i=start;i<=end;i++)
		if(a[i]<a[indexOfMinimum])
			indexOfMinimum = i;
	return indexOfMinimum;
}


template<class T> 
void selectionSort(T a[], int n)
{
	for(int i=0;i<n;i++){
		int k = arraySmallest(a,i,n-1);
		swap(a[i],a[k]);
	}
}

///////////////////////////////////////////////////////////

template<class T>
void mergeSort(T A[],int p,int r)
{

   if(p<r)  {
         int q = (p+r)/2;
         mergeSort(A,p,q);
         mergeSort(A,q+1,r);
		 Merge(A,p,q,r);
   } 
 }

template<class T>
void Merge(T  A[], int p, int q, int r)
{
   T * B = new T[q-p+1];
   T * C = new T[r-q];
   T * D = new T[r-p+1];
   
   for(int i=p;i<=q;i++) B[i-p]=A[i];      //copy A[p...q] to B
   for(i=q+1;i<=r;i++) C[i-q-1]=A[i];       //copy A[q+1...r] to C
   
   merge15(B,q-p+1,C,r-q,D);            // from lecture 15
   // merges C and B into a sorted array and stores it in D 
   
   for(i=p;i<=r;i++) A[i]=D[i-p];           //copy D to A[p...r] 
   
   delete [] B; 
   delete [] C; 
   delete [] D;
}


template<class T>
void merge15(const T L[],int m,const T R[], int n, T C[] ) // C is passed by  reference. 
 //Thus we assume that memory is allocated for C before calling the function
{
   int i =0, j = 0; 
   for(int k = 0;k<m+n;k++) 
   {
      if (i< m &&  j < n) 
          if (L[i]<R[j]) 
               { C[k] = L[i];  i++; }  
          else  
              {  C[k] = R[j];   j++; }
      else if  (i==m) {C[k] = R[j]; j = j+1;} // if all the elements of L are in C,  dump R in C
      else if  (j==n) {C[k] = L[i];  i = i+1;} // if all the elements of R are in C,  dump L in C
  }
}



/////////////////////////////////////////////////////////////////

template<class T>
void randQuickSort(T A[], int low, int high)
{
	if(high>low){
		int randomIndex = low + rand()%(high-low+1);
		swap(A[randomIndex],A[high]);
		int q = partition(A,low,high);
		randQuickSort(A,low,q-1);
		randQuickSort(A,q+1,high);
	}
}


template<class T>
int partition(T A[],int low,int high)
{
    int i=low;
	if(high-low<1) return 0;
    int j=high-1;
    while (i<j) {
      	while (A[i]<=A[high] && i<j)
	    	i++;
	    while (A[j]>=A[high] && i<j)
		    j--;
		swap(A[i],A[j]);
    }   
	if(A[i]>=A[high])  {
		swap(A[i],A[high]);
		return i; 
	}
	else {
		swap(A[i+1],A[high]);
		return i+1;
	}
}

/////////////////////////////////////////////////////////////////
