#include <iostream>
using namespace std;

const int matrixSize = 4 ;


void createArithmeticSeq(int A[matrixSize*matrixSize]);
void matricize(int A[matrixSize*matrixSize],int B[matrixSize][matrixSize]);
void magicCheck(int A[matrixSize*matrixSize],int B[matrixSize][matrixSize]);
void reverseDiagonal(int B[matrixSize][matrixSize]);
void printMatrix(int B[matrixSize][matrixSize]);
void testMagicCheck();




int main()
{
	int list[matrixSize*matrixSize];
	int matrix[matrixSize][matrixSize];
	createArithmeticSeq(list);
	matricize(list,matrix);
	reverseDiagonal(matrix);
	printMatrix(matrix);
	magicCheck(list,matrix);
	return 0;
}




void createArithmeticSeq(int A[matrixSize*matrixSize]){
	int first,diff;
	cout << "Please enter the first term of the arithmetic sequence" <<endl;
	cin >> first;
	cout << "Please enter the difference between 2 consecutive terms"<<endl;
	cin >> diff;
	int val = first;
	for(int i=0;i<matrixSize*matrixSize;i++){
		A[i]=val;
		val+=diff;
	}
}
void matricize(int A[matrixSize*matrixSize],int B[matrixSize][matrixSize]){
	int k=0;
	for(int i=0;i<matrixSize;i++)
		for(int j=0;j<matrixSize;j++)
			B[i][j]=A[k++];	
}


void reverseDiagonal(int B[matrixSize][matrixSize]){
	for(int i=0;i<matrixSize/2;i++){
		swap(B[i][i],B[matrixSize-i-1][matrixSize-i-1]);
		swap(B[i][matrixSize-i-1],B[matrixSize-i-1][i]);
	}
}

void magicCheck(int A[matrixSize*matrixSize],int B[matrixSize][matrixSize]){
	int sum=0,magicNumber;
	int i,j;
	for(i=0;i<matrixSize*matrixSize;i++)
		sum += A[i];

	magicNumber = sum/4;
	bool isMagic=true;
	int rowSums[matrixSize]={0};
	int colSums[matrixSize]={0};
	int firstDiagonalSum=0;
	int secondDiagonalSum=0;
	for(i=0;i<matrixSize;i++){
		for(j=0;j<matrixSize;j++){
			rowSums[i]+=B[i][j];
			colSums[j]+=B[i][j];
			if(i==j) firstDiagonalSum+=B[i][j];
			if(i==matrixSize-1-j) secondDiagonalSum+=B[i][j];
		}
	}
	for(i=0;i<matrixSize;i++){
		if((rowSums[i]!=magicNumber)||(colSums[i]!=magicNumber)){
			isMagic = false;
			break;
		}
	}
	if((firstDiagonalSum!=magicNumber)||(secondDiagonalSum!=magicNumber)) isMagic = false;

	if(isMagic) cout << "It is a magic square" << endl;
	else cout << "it is not a magic square" << endl;
}
void printMatrix(int B[matrixSize][matrixSize]){
	cout << endl;
	for(int i=0;i<matrixSize;i++){
		for(int j=0;j<matrixSize;j++){
			cout << B[i][j] << "\t" ;		
		}
		cout <<endl<<endl<<endl<<endl<<endl ;
	}
}


